void GetMessageFile(char *Class,char *Src,char *MsgFile)
{
  HKEY hKey=NULL;
  MsgFile[0]=0;
  if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,EVENTLOG_KEY,0,KEY_READ,&hKey)==ERROR_SUCCESS)
  {
    char NameBuffer[MAX_PATH]; LONG Result;
    for(int i=0;;i++)
    {
      Result=RegEnumKey(hKey,i,NameBuffer,sizeof(NameBuffer));
      if(Result==ERROR_NO_MORE_ITEMS)
        break;
      if(Result==ERROR_SUCCESS)
      {
        char Key[1024];
        char MsgFileWork[MAX_PATH];
        HKEY hKey2; DWORD Type; DWORD DataSize=0;
        sprintf(Key,"%s\\%s\\%s",EVENTLOG_KEY,NameBuffer,Src);
        if((RegOpenKeyEx(HKEY_LOCAL_MACHINE,Key,0,KEY_QUERY_VALUE,&hKey2))==ERROR_SUCCESS)
        {
          DataSize=sizeof(MsgFileWork);
          if(RegQueryValueEx(hKey2,"EventMessageFile",0,&Type,(LPBYTE)MsgFileWork,&DataSize)==ERROR_SUCCESS)
          {
            ExpandEnvironmentStrings(MsgFileWork,MsgFile,MAX_PATH);
            CharToOem(MsgFile,MsgFile);
          }
          RegCloseKey(hKey2);
          break;
        }
      }
    }
    RegCloseKey(hKey);
  }
}

static char *GetMsgAnsi(int MsgId)
{
  static char buff[SMALL_BUFFER];
  char *MsgOem=GetMsg(MsgId);
  if(strlen(MsgOem)<SMALL_BUFFER)
    OemToChar(MsgOem,buff);
  else
    sprintf(buff,"%s","invalid message");
  return buff;
}

char *FormatLogMessage(char *Class,EVENTLOGRECORD *rec)
{
  char *SourceName=(char *)(rec+1),filename[MAX_PATH]; HINSTANCE lib; char **msgs=NULL;
  char *fmsg; DWORD fsize=0; char *winerror=NULL; char *res=NULL;
  if(!SourceName[0]) return NULL;
  GetMessageFile(Class,SourceName,filename);
  if(rec->NumStrings)
  {
    int offset=0;
    msgs=(char **)malloc(rec->NumStrings*sizeof(char *));
    if(!msgs) return NULL;
    for(int i=0;i<rec->NumStrings;i++)
    {
      msgs[i]=((char *)rec)+rec->StringOffset+offset;
      offset+=strlen(msgs[i])+1;
      if((!strncmp("%%",msgs[i],2))&&(strlen(msgs[i])>2))
      {
        char *endptr;
        long err=strtol(msgs[i]+2,&endptr,10);
        if((err>0)&&(!*endptr))
        {
          if(FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_ARGUMENT_ARRAY,NULL,err,LANG_NEUTRAL,(char *)&winerror,512,NULL))
            msgs[i]=winerror;
        }
      }
    }
  }
  if(filename[0])
  {
    lib=LoadLibrary(filename);
    if(lib)
    {
      fsize=FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_HMODULE|FORMAT_MESSAGE_ARGUMENT_ARRAY,lib,rec->EventID,LANG_NEUTRAL,(char *)&fmsg,512,msgs);
      FreeLibrary(lib);
    }
  }
  if(fsize)
  {
    res=(char *)malloc(fsize+1);
    if(res)
      memcpy(res,fmsg,fsize+1);
    LocalFree(fmsg);
  }
  else
  {
    int mem_size=1;
    for(int i=0;i<rec->NumStrings;i++)
      mem_size+=2+strlen(msgs[i]);
    mem_size+=2+strlen(GetMsg(mFileErr1))+9+strlen((char *)(rec+1));
    mem_size+=2+strlen(GetMsg(mFileErr2));
    res=(char *)malloc(mem_size);
    if(res)
    {
      sprintf(res,GetMsgAnsi(mFileErr1),rec->EventID&0xffff,(char *)(rec+1));
      sprintf(res,"%s%s",res,"\r\n");
      sprintf(res,"%s%s",res,GetMsgAnsi(mFileErr2));
      sprintf(res,"%s%s",res,"\r\n");
      for(int i=0;i<rec->NumStrings;i++)
      {
        sprintf(res,"%s%s",res,msgs[i]);
        sprintf(res,"%s%s",res,"\r\n");
      }
    }
  }
  if(winerror) LocalFree(winerror);
  if(msgs) free(msgs);
  CharToOem(res,res);
  return res;
}

char *GetComputerName(EVENTLOGRECORD *rec)
{
  static char CompName[SMALL_BUFFER];
  char *SourceName=(char *)(rec+1);
  sprintf(CompName,"%s",SourceName+strlen(SourceName)+1);
  CharToOem(CompName,CompName);
  return CompName;
}

char *GetUserName(EVENTLOGRECORD *rec)
{
  static char UserName[SMALL_BUFFER];
  char DomainName[SMALL_BUFFER];
  DWORD UserNameSize=sizeof(UserName),DomainNameSize=sizeof(DomainName);
  SID_NAME_USE use;
  if((!IsValidSid((char *)rec+rec->UserSidOffset))||(!LookupAccountSid(NULL,(char *)rec+rec->UserSidOffset,UserName,&UserNameSize,DomainName,&DomainNameSize,&use))) //LOCAL
    strcpy(UserName,"N/A");
  CharToOem(UserName,UserName);
  return UserName;
}

char *GetType(DWORD type)
{
  switch(type)
  {
    case EVENTLOG_ERROR_TYPE:
      return GetMsg(mTypeError);
    case EVENTLOG_WARNING_TYPE:
      return GetMsg(mTypeWarning);
    case EVENTLOG_INFORMATION_TYPE:
      return GetMsg(mTypeInformation);
    case EVENTLOG_AUDIT_SUCCESS:
      return GetMsg(mTypeSuccessAudit);
    case EVENTLOG_AUDIT_FAILURE:
      return GetMsg(mTypeFailureAudit);
  }
  return GetMsg(mTypeUnknown);
}

BOOL CheckLogName(EventViewer *panel,const char *LogName)
{
  BOOL res=FALSE; char LogNameAnsi[SMALL_BUFFER];
  OemToChar(LogName,LogNameAnsi);
  HANDLE evt=OpenEventLog(panel->computer_ptr,LogNameAnsi); //REMOTE
  if(evt)
  {
    CloseEventLog(evt);
    res=TRUE;
  }
  return res;
}